Loading...
Searching...
No Matches
or/ungbr: Generate Q or P from bidiagonal reduction
Dense LA » Singular Value Decomposition (SVD)

## Functions

magma_int_t | magma_cungbr (magma_vect_t vect, magma_int_t m, magma_int_t n, magma_int_t k, magmaFloatComplex *A, magma_int_t lda, magmaFloatComplex *tau, magmaFloatComplex *work, magma_int_t lwork, magma_int_t *info)
| CUNGBR generates one of the complex unitary matrices Q or P**H determined by CGEBRD when reducing a complex matrix A to bidiagonal form: A = Q * B * P**H.
magma_int_t | magma_dorgbr (magma_vect_t vect, magma_int_t m, magma_int_t n, magma_int_t k, double *A, magma_int_t lda, double *tau, double *work, magma_int_t lwork, magma_int_t *info)
| DORGBR generates one of the real orthogonal matrices Q or P**H determined by DGEBRD when reducing a real matrix A to bidiagonal form: A = Q * B * P**H.
magma_int_t | magma_sorgbr (magma_vect_t vect, magma_int_t m, magma_int_t n, magma_int_t k, float *A, magma_int_t lda, float *tau, float *work, magma_int_t lwork, magma_int_t *info)
| SORGBR generates one of the real orthogonal matrices Q or P**H determined by SGEBRD when reducing a real matrix A to bidiagonal form: A = Q * B * P**H.
magma_int_t | magma_zungbr (magma_vect_t vect, magma_int_t m, magma_int_t n, magma_int_t k, magmaDoubleComplex *A, magma_int_t lda, magmaDoubleComplex *tau, magmaDoubleComplex *work, magma_int_t lwork, magma_int_t *info)
| ZUNGBR generates one of the complex unitary matrices Q or P**H determined by ZGEBRD when reducing a complex matrix A to bidiagonal form: A = Q * B * P**H.

## Detailed Description

## Function Documentation

## magma_cungbr()

magma_int_t magma_cungbr | ( | magma_vect_t | vect,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaFloatComplex * | A,
|  | magma_int_t | lda,
|  | magmaFloatComplex * | tau,
|  | magmaFloatComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

CUNGBR generates one of the complex unitary matrices Q or P**H determined by CGEBRD when reducing a complex matrix A to bidiagonal form: A = Q * B * P**H.

Q and P**H are defined as products of elementary reflectors H(i) or G(i) respectively.

If VECT = MagmaQ, A is assumed to have been an M-by-K matrix, and Q is of order M: if m >= k, Q = H(1) H(2) . . . H(k) and CUNGBR returns the first n columns of Q, where m >= n >= k; if m < k, Q = H(1) H(2) . . . H(m-1) and CUNGBR returns Q as an M-by-M matrix.

If VECT = MagmaP, A is assumed to have been a K-by-N matrix, and P**H is of order N: if k < n, P**H = G(k) . . . G(2) G(1) and CUNGBR returns the first m rows of P**H, where n >= m >= k; if k >= n, P**H = G(n-1) . . . G(2) G(1) and CUNGBR returns P**H as an N-by-N matrix.

Parameters

  [in] | vect | magma_vect_t Specifies whether the matrix Q or the matrix P**H is required, as defined in the transformation applied by CGEBRD: = MagmaQ: generate Q; = MagmaP: generate P**H.
  [in] | m | magma_int_t The number of rows of the matrix Q or P**H to be returned. M >= 0.
  [in] | n | magma_int_t The number of columns of the matrix Q or P**H to be returned. N >= 0. If VECT = MagmaQ, M >= N >= min(M,K); if VECT = MagmaP, N >= M >= min(N,K).
  [in] | k | magma_int_t If VECT = MagmaQ, the number of columns in the original M-by-K matrix reduced by CGEBRD. If VECT = MagmaP, the number of rows in the original K-by-N matrix reduced by CGEBRD. K >= 0.
  [in,out] | A | magmaFloatComplex array, dimension (LDA,N) On entry, the vectors which define the elementary reflectors, as returned by CGEBRD. On exit, the M-by-N matrix Q or P**H.
  [in] | lda | magma_int_t The leading dimension of the array A. LDA >= M.
  [in] | tau | magmaFloatComplex array, dimension (min(M,K)) if VECT = MagmaQ (min(N,K)) if VECT = MagmaP TAU(i) must contain the scalar factor of the elementary reflector H(i) or G(i), which determines Q or P**H, as returned by CGEBRD in its array argument TAUQ or TAUP.
  [out] | work | magmaFloatComplex array, dimension (MAX(1,LWORK)) On exit, if *info = 0, WORK(1) returns the optimal LWORK.
  [in] | lwork | magma_int_t The dimension of the array WORK. LWORK >= max(1,min(M,N)). For optimum performance LWORK >= min(M,N)*NB, where NB is the optimal blocksize.

If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

Parameters

  [out]

  info

  magma_int_t
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_dorgbr()

magma_int_t magma_dorgbr | ( | magma_vect_t | vect,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | double * | A,
|  | magma_int_t | lda,
|  | double * | tau,
|  | double * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

DORGBR generates one of the real orthogonal matrices Q or P**H determined by DGEBRD when reducing a real matrix A to bidiagonal form: A = Q * B * P**H.

Q and P**H are defined as products of elementary reflectors H(i) or G(i) respectively.

If VECT = MagmaQ, A is assumed to have been an M-by-K matrix, and Q is of order M: if m >= k, Q = H(1) H(2) . . . H(k) and DORGBR returns the first n columns of Q, where m >= n >= k; if m < k, Q = H(1) H(2) . . . H(m-1) and DORGBR returns Q as an M-by-M matrix.

If VECT = MagmaP, A is assumed to have been a K-by-N matrix, and P**H is of order N: if k < n, P**H = G(k) . . . G(2) G(1) and DORGBR returns the first m rows of P**H, where n >= m >= k; if k >= n, P**H = G(n-1) . . . G(2) G(1) and DORGBR returns P**H as an N-by-N matrix.

Parameters

  [in] | vect | magma_vect_t Specifies whether the matrix Q or the matrix P**H is required, as defined in the transformation applied by DGEBRD: = MagmaQ: generate Q; = MagmaP: generate P**H.
  [in] | m | magma_int_t The number of rows of the matrix Q or P**H to be returned. M >= 0.
  [in] | n | magma_int_t The number of columns of the matrix Q or P**H to be returned. N >= 0. If VECT = MagmaQ, M >= N >= min(M,K); if VECT = MagmaP, N >= M >= min(N,K).
  [in] | k | magma_int_t If VECT = MagmaQ, the number of columns in the original M-by-K matrix reduced by DGEBRD. If VECT = MagmaP, the number of rows in the original K-by-N matrix reduced by DGEBRD. K >= 0.
  [in,out] | A | double array, dimension (LDA,N) On entry, the vectors which define the elementary reflectors, as returned by DGEBRD. On exit, the M-by-N matrix Q or P**H.
  [in] | lda | magma_int_t The leading dimension of the array A. LDA >= M.
  [in] | tau | double array, dimension (min(M,K)) if VECT = MagmaQ (min(N,K)) if VECT = MagmaP TAU(i) must contain the scalar factor of the elementary reflector H(i) or G(i), which determines Q or P**H, as returned by DGEBRD in its array argument TAUQ or TAUP.
  [out] | work | double array, dimension (MAX(1,LWORK)) On exit, if *info = 0, WORK(1) returns the optimal LWORK.
  [in] | lwork | magma_int_t The dimension of the array WORK. LWORK >= max(1,min(M,N)). For optimum performance LWORK >= min(M,N)*NB, where NB is the optimal blocksize.

If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

Parameters

  [out]

  info

  magma_int_t
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_sorgbr()

magma_int_t magma_sorgbr | ( | magma_vect_t | vect,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | float * | A,
|  | magma_int_t | lda,
|  | float * | tau,
|  | float * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

SORGBR generates one of the real orthogonal matrices Q or P**H determined by SGEBRD when reducing a real matrix A to bidiagonal form: A = Q * B * P**H.

Q and P**H are defined as products of elementary reflectors H(i) or G(i) respectively.

If VECT = MagmaQ, A is assumed to have been an M-by-K matrix, and Q is of order M: if m >= k, Q = H(1) H(2) . . . H(k) and SORGBR returns the first n columns of Q, where m >= n >= k; if m < k, Q = H(1) H(2) . . . H(m-1) and SORGBR returns Q as an M-by-M matrix.

If VECT = MagmaP, A is assumed to have been a K-by-N matrix, and P**H is of order N: if k < n, P**H = G(k) . . . G(2) G(1) and SORGBR returns the first m rows of P**H, where n >= m >= k; if k >= n, P**H = G(n-1) . . . G(2) G(1) and SORGBR returns P**H as an N-by-N matrix.

Parameters

  [in] | vect | magma_vect_t Specifies whether the matrix Q or the matrix P**H is required, as defined in the transformation applied by SGEBRD: = MagmaQ: generate Q; = MagmaP: generate P**H.
  [in] | m | magma_int_t The number of rows of the matrix Q or P**H to be returned. M >= 0.
  [in] | n | magma_int_t The number of columns of the matrix Q or P**H to be returned. N >= 0. If VECT = MagmaQ, M >= N >= min(M,K); if VECT = MagmaP, N >= M >= min(N,K).
  [in] | k | magma_int_t If VECT = MagmaQ, the number of columns in the original M-by-K matrix reduced by SGEBRD. If VECT = MagmaP, the number of rows in the original K-by-N matrix reduced by SGEBRD. K >= 0.
  [in,out] | A | float array, dimension (LDA,N) On entry, the vectors which define the elementary reflectors, as returned by SGEBRD. On exit, the M-by-N matrix Q or P**H.
  [in] | lda | magma_int_t The leading dimension of the array A. LDA >= M.
  [in] | tau | float array, dimension (min(M,K)) if VECT = MagmaQ (min(N,K)) if VECT = MagmaP TAU(i) must contain the scalar factor of the elementary reflector H(i) or G(i), which determines Q or P**H, as returned by SGEBRD in its array argument TAUQ or TAUP.
  [out] | work | float array, dimension (MAX(1,LWORK)) On exit, if *info = 0, WORK(1) returns the optimal LWORK.
  [in] | lwork | magma_int_t The dimension of the array WORK. LWORK >= max(1,min(M,N)). For optimum performance LWORK >= min(M,N)*NB, where NB is the optimal blocksize.

If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

Parameters

  [out]

  info

  magma_int_t
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_zungbr()

magma_int_t magma_zungbr | ( | magma_vect_t | vect,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaDoubleComplex * | A,
|  | magma_int_t | lda,
|  | magmaDoubleComplex * | tau,
|  | magmaDoubleComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

ZUNGBR generates one of the complex unitary matrices Q or P**H determined by ZGEBRD when reducing a complex matrix A to bidiagonal form: A = Q * B * P**H.

Q and P**H are defined as products of elementary reflectors H(i) or G(i) respectively.

If VECT = MagmaQ, A is assumed to have been an M-by-K matrix, and Q is of order M: if m >= k, Q = H(1) H(2) . . . H(k) and ZUNGBR returns the first n columns of Q, where m >= n >= k; if m < k, Q = H(1) H(2) . . . H(m-1) and ZUNGBR returns Q as an M-by-M matrix.

If VECT = MagmaP, A is assumed to have been a K-by-N matrix, and P**H is of order N: if k < n, P**H = G(k) . . . G(2) G(1) and ZUNGBR returns the first m rows of P**H, where n >= m >= k; if k >= n, P**H = G(n-1) . . . G(2) G(1) and ZUNGBR returns P**H as an N-by-N matrix.

Parameters

  [in] | vect | magma_vect_t Specifies whether the matrix Q or the matrix P**H is required, as defined in the transformation applied by ZGEBRD: = MagmaQ: generate Q; = MagmaP: generate P**H.
  [in] | m | magma_int_t The number of rows of the matrix Q or P**H to be returned. M >= 0.
  [in] | n | magma_int_t The number of columns of the matrix Q or P**H to be returned. N >= 0. If VECT = MagmaQ, M >= N >= min(M,K); if VECT = MagmaP, N >= M >= min(N,K).
  [in] | k | magma_int_t If VECT = MagmaQ, the number of columns in the original M-by-K matrix reduced by ZGEBRD. If VECT = MagmaP, the number of rows in the original K-by-N matrix reduced by ZGEBRD. K >= 0.
  [in,out] | A | magmaDoubleComplex array, dimension (LDA,N) On entry, the vectors which define the elementary reflectors, as returned by ZGEBRD. On exit, the M-by-N matrix Q or P**H.
  [in] | lda | magma_int_t The leading dimension of the array A. LDA >= M.
  [in] | tau | magmaDoubleComplex array, dimension (min(M,K)) if VECT = MagmaQ (min(N,K)) if VECT = MagmaP TAU(i) must contain the scalar factor of the elementary reflector H(i) or G(i), which determines Q or P**H, as returned by ZGEBRD in its array argument TAUQ or TAUP.
  [out] | work | magmaDoubleComplex array, dimension (MAX(1,LWORK)) On exit, if *info = 0, WORK(1) returns the optimal LWORK.
  [in] | lwork | magma_int_t The dimension of the array WORK. LWORK >= max(1,min(M,N)). For optimum performance LWORK >= min(M,N)*NB, where NB is the optimal blocksize.

If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

Parameters

  [out]

  info

  magma_int_t
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value